/**
* @version $Id: $
* @package osm-things
* @copyright Copyright (C) 2008 Sebastian Klemm.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

function checkall(state) {
	for(i=0; i< document.batch_import_form.elements['bfiles[]'].length; ++i) { //'
		document.batch_import_form.elements['bfiles[]'][i].checked = state;	//'
	}
}

function startImport(path, isSingleFile) {
	document.getElementById('dynamicContent_Wait').style.visibility = "visible";
	document.getElementById('dynamicContent_Done').style.visibility = "hidden";
	
	if(!isSingleFile) {
		for(i=0; i< document.batch_import_form.elements['bfiles[]'].length; ++i) { //'
			if(document.batch_import_form.elements['bfiles[]'][i].checked) { //'
				var description = document.batch_import_form.elements['description'].value;
				var filename = document.batch_import_form.elements['bfiles[]'][i].value;	//'
				document.getElementById('dynamicContent').innerHTML = filename;
				setRequest(i+1, path+filename, description, '');
				// for synchronous requests we must call this on our own
				interpretRequest();
			}
		}
	} else {
		var description = document.batch_import_form.elements['description'].value;
		var filename = document.batch_import_form.elements['bfile'].value;
		document.getElementById('dynamicContent').innerHTML = filename;
		setRequest(1, path+filename, description, '');
		// for synchronous requests we must call this on our own
		interpretRequest();
	} 
	document.getElementById('dynamicContent').innerHTML = "";
	document.getElementById('dynamicContent_Wait').style.visibility = "hidden";
	document.getElementById('dynamicContent_Done').style.visibility = "visible";
}

// set and send XML Http request
function setRequest(id, file, description, option) {
	// Request erzeugen
	if (window.XMLHttpRequest) {
		request = new XMLHttpRequest(); // Mozilla, Safari, Opera
	} else if (window.ActiveXObject) {
		try {
			request = new ActiveXObject('Msxml2.XMLHTTP'); // IE 5
		} catch (e) {
			try {
				request = new ActiveXObject('Microsoft.XMLHTTP'); // IE 6
			} catch (e) {}
		}
	}

	// check if browser is AJAX capable
	if (!request) {
		alert("Your browser doesn't support AJAX!<br/>Ihr Browser ist nicht AJAX-fähig!");
		return false;
	} else {
		var url = "import.php?type=gpx&file=" + encodeURIComponent(file) + "&id=" + id;
		url += "&description=" + description;
		// open request
		request.open('GET', url, false);
		// requestheader for POST
		//request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		// satisfy some mozilla browsers
		request.overrideMimeType('text/xml');
		// send request
		request.send(null);
		// interpret request (callback for async requests)
		//request.onreadystatechange = interpretRequest;
	}
}

// interpret XML Http request
function interpretRequest() {
	switch (request.readyState) {
		case 4:
			if (request.status != 200) {
				alert("Request Error / Fehler:\n"+request.status);
			} else {
				// request answer is XML format
				var xmlDoc	= request.responseXML;
				// read XML answer
				var type	= xmlDoc.getElementsByTagName('import')[0].getAttribute('type');
				var id		= xmlDoc.getElementsByTagName('import')[0].getAttribute('id');
				var file	= xmlDoc.getElementsByTagName('import')[0].getAttribute('file');
				var db_id	= xmlDoc.getElementsByTagName('import')[0].getAttribute('lid');
				var status	= xmlDoc.getElementsByTagName('import')[0].getAttribute('status');
				var message	= xmlDoc.getElementsByTagName('import')[0].getAttribute('msg');
				
				id = parseInt(id);
				db_id = parseInt(db_id);
				status = parseInt(status);
				message = decodeURIComponent(message);
				if (status == 0) {
					icon = "tick_12.png";
				}else {
					icon = "cancel_12.png";
				}
				
				document.getElementById('status_' + String(id)).innerHTML = message;
				if (status == 0) {
					document.getElementById('status_' + String(id)).innerHTML += 
					" <a href='traces.php?task=details&id="+ String(db_id) +"'>(GPX-ID)</a>";
				}
				document.getElementById('status_icon_' + String(id)).innerHTML = 
					"<img src='./installation/images/"+ icon +"'>";
			}
			break;
		default:
			break;
	}
}